/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (C) 1998, Emmanuel CURIS
   Cration : le 27 novembre 1998

   Module de cration d'un modle structural

   Variables globales dfinies pour ce module
*/

#define VARIABLES_ATOMES 

#include <stdio.h>
#include <stdlib.h>

#include "systeme.h"

#include "atomes.h"
#include "tracer.h" /* Pour le mode d'affichage des molcules */

#include "var_atomes.txt"

Atome *ATM_courant = NULL; /* Atome slectionn, affich dans le slecteur d'atomes */

Molecule *premiere_molecule = NULL, *derniere_molecule = NULL; /* Liste chane des molcules */
Molecule *mol_courante = NULL; /* Molcule actuellement traite */

Fenetre *fen_vue_3d = NULL;
unsigned long nombre_molecules = 0;
int mode_vue3d = V3D_VOIR_ATOMES | V3D_VOIR_LIAISONS | V3D_MODELE_SPECIAL; /* Modes pour dessiner la molcule */

#ifdef AVEC_OPEN_GL_
GLuint liste_molecule = 0; /* liste d'affichage des atomes de la molcule */
GLuint liste_chemin = 0;   /* liste d'affichage du chemin actuel */
GLuint liste_liaisons = 0; /* liste d'affichage du schma de liaisons */
#endif

/* Les noms des diffrents groupes d'espace */
const char *txt_tricli[] = {
  txt_aucun_groupe,
  "1 : P1 = 1 = C11",
  "2 : P-1 = -1 = Ci1",
  "2 : P-1 d"e_AIGU"cal"e_AIGU };

const char *txt_hexagonal[] = {
  txt_aucun_groupe,
  "176 : P63/m" };

const char *txt_rhombo[] = {
  txt_aucun_groupe,
  "160 : R3m (axes rhomb.)",
  "160 : R3m (axes hexa.)"};

const char *txt_orthoP[] = {
  txt_aucun_groupe,
  "62 : Pnma = D2h 16 = mmm" };

const char *txt_monoP[] = {
  txt_aucun_groupe,
  " 3 : P2 = C21 = P 1 2/m 1",
  " 4 : P21 = C2",
  " 6 : Pm = Cs1",
  " 7 : Pc = Cs",
  "10 : P2/m = C2h1",
  "11 : P21/m = C2h",
  "13 : P2/c = C2h^4",
  "14 : P21/c = C2h^5",
  "P21/n"
};

const char *txt_monoC[] = {
  txt_aucun_groupe,
  "15 : C2/c = C6_2h",
  " 5 : C2   = C3_2",
  "12 : C2/m = C3_2h",
  " 8 : Cm   = C3_5",
  " 9 : Cc   = C4_5"
};
