/* LASE - Logiciel d'Analyse des Spectres Exprimentaux
   (C) 1996-2003, Emmanuel Curis

   Interface graphique : routines gnrales indpendantes du systme

   Routines de dessin fondamentales
   Dclarations (indpendantes de LASE)
   Les dfinitions sont en fait, pour la plupart, des alias ->  voir dans Bib_X, Bib_W32
*/

#ifndef BI_DESSIN_COMMUN_H_
# define BI_DESSIN_COMMUN_H_	/* Protection contre l'inclusion multiple */

/* ~-~-~-~-~-~-~-~ Fonctions de base, sans contrle ~-~-~-~-~-~-~-~ */

/* -------- Version pour X-Window -------- */

#ifdef _UNIX_
/* Les prototypes sont dans Bib_X/X_dessins.h */
# define TRC_Couleur   X_TRC_Couleur
# define TRC_Degrade   X_TRC_CouleurDegrade
# define TRC_Epaisseur X_TRC_EpaisseurLigne
# define TRC_Mode      X_TRC_ModeEcriture
# define TRC_Motif     X_TRC_MotifRemplissage
# define TRC_Style     X_TRC_StyleLigne

# define TRC_CreerDegrade X_TRC_CreerDegrade

# define TRC_Point  X_TRC_Point
# define TRC_Marque X_TRC_Marque

# define TRC_Ligne       X_TRC_Ligne
# define TRC_LigneBrisee X_TRC_LigneBrisee

# define TRC_Triangle      X_TRC_Triangle
# define TRC_TrianglePlein X_TRC_TrianglePlein

# define TRC_Rectangle      X_TRC_Rectangle
# define TRC_RectanglePlein X_TRC_RectanglePlein

# define TRC_ArcCercle  X_TRC_ArcCercle
# define TRC_ArcEllipse X_TRC_ArcEllipse
# define TRC_Cercle  X_TRC_Cercle
# define TRC_Disque  X_TRC_Disque
# define TRC_Ellipse X_TRC_Ellipse

# define TRC_Texte X_TRC_Texte
#endif

/* -------- Version pour Windows -------- */

#ifdef _WINDOWS_
/* Les prototypes sont dans Bib_W32/W_dessins.h */
# define TRC_Couleur   W_TRC_Couleur
# define TRC_Degrade   W_TRC_CouleurDegrade
# define TRC_Epaisseur W_TRC_EpaisseurLigne
# define TRC_Mode      W_TRC_ModeEcriture
# define TRC_Motif     W_TRC_MotifRemplissage
# define TRC_Style     W_TRC_StyleLigne

# define TRC_CreerDegrade W_TRC_CreerDegrade

# define TRC_Point  W_TRC_Point
# define TRC_Marque W_TRC_Marque

# define TRC_Ligne       W_TRC_Ligne
# define TRC_LigneBrisee W_TRC_LigneBrisee

# define TRC_Triangle      W_TRC_Triangle
# define TRC_TrianglePlein W_TRC_TrianglePlein

# define TRC_Rectangle      W_TRC_Rectangle
# define TRC_RectanglePlein W_TRC_RectanglePlein

# define TRC_ArcCercle  W_TRC_ArcCercle
# define TRC_ArcEllipse W_TRC_ArcEllipse
# define TRC_Cercle  W_TRC_Cercle
# define TRC_Disque  W_TRC_Disque
# define TRC_Ellipse W_TRC_Ellipse

# define TRC_Texte W_TRC_Texte
#endif

/* ~-~-~-~-~-~-~-~ Fonctions de base, avec contrle (indication de zone de clip) ~-~-~-~-~-~-~-~ */

/* -------- Version pour X-Window -------- */

#ifdef _UNIX_
# define TRC_Z_Point  X_TRC_Z_Point
# define TRC_Z_Marque X_TRC_Z_Marque

# define TRC_Z_Ligne  X_TRC_Z_Ligne

# define TRC_Z_Triangle       X_TRC_Z_Triangle
# define TRC_Z_TrianglePlein  X_TRC_Z_TrianglePlein

# define TRC_Z_Rectangle      X_TRC_Z_Rectangle
# define TRC_Z_RectanglePlein X_TRC_Z_RectanglePlein

# define TRC_Z_Cercle  X_TRC_Z_Cercle
# define TRC_Z_Disque  X_TRC_Z_Disque
# define TRC_Z_Ellipse X_TRC_Z_Ellipse

# define TRC_Z_Texte   X_TRC_Z_Texte
#endif

/* -------- Version pour Windows -------- */

#ifdef _WINDOWS_
# define TRC_Z_Point  W_TRC_Z_Point
# define TRC_Z_Marque W_TRC_Z_Marque

# define TRC_Z_Ligne  W_TRC_Z_Ligne

# define TRC_Z_Triangle       W_TRC_Z_Triangle
# define TRC_Z_TrianglePlein  W_TRC_Z_TrianglePlein

# define TRC_Z_Rectangle      W_TRC_Z_Rectangle
# define TRC_Z_RectanglePlein W_TRC_Z_RectanglePlein

# define TRC_Z_Cercle  W_TRC_Z_Cercle
# define TRC_Z_Disque  W_TRC_Z_Disque
# define TRC_Z_Ellipse W_TRC_Z_Ellipse

# define TRC_Z_Texte   W_TRC_Z_Texte
#endif

/* ~-~-~-~-~-~-~-~ Fonctions semi de base, moins spcifiques ~-~-~-~-~-~-~-~ */

/* -------- Init des dessins dans une fentre classique --- */

#define TRC_InitDessins(f,x,y,l,h) { TRC_Couleur( BLANC ) ; TRC_Epaisseur( 1 ); TRC_Style( BI_CONTINU ) ; TRC_Mode( MD_REMPLACE );\
                                     TRC_RectanglePlein( (f), (x), (y), (l), (h) ); }
#define TRC_InitPointeur { TRC_Mode( MD_INVERSE ); TRC_Style( BI_CONTINU ); TRC_Couleur( NOIR ); TRC_Epaisseur( 0 ); }

/* -------- Conversion cran <-> rgion 2D du plan -------- */

int TRC_Echelles     (unsigned int largeur, unsigned int hauteur, double x_min, double x_max, double y_min, double y_max,
		      double *echelle_X, double *echelle_Y);
int TRC_EcranVersPlan(int x_BG, int y_BG, unsigned int largeur, unsigned int hauteur,
		      double x_min, double x_max, double y_min, double y_max,
		      int x_ecran, int y_ecran, double *x_vrai, double *y_vrai);
int TRC_PlanVersEcran(int x_BG, int y_BG, unsigned int largeur, unsigned int hauteur,
		      double x_min, double x_max, double y_min, double y_max,
		      double x_vrai, double y_vrai, int *x_ecran, int *y_ecran);

/* Macros de conversion cran <-> 2D ; echelle en vrai / pixel
   ATTENTION, x_BG et y_BG peuvent tre en unsigned -> pour avoir des valeurs correctes quand on clique en-dehors, il faut signer !
 */
#define TRC_ConvertitX_PvE(x,x_min,xBG,echelle) ( (xBG) + rint( ( (x) - (x_min) ) / (echelle) ) )
#define TRC_ConvertitX_EvP(x,x_min,xBG,echelle) ( (x_min) + ( ( ( (double) (x) - (double) (xBG) ) ) * (echelle) ) )

#define TRC_ConvertitY_PvE(y,y_min,yBG,echelle) ( (yBG) - rint( ( (y) - (y_min) ) / (echelle) ) )
#define TRC_ConvertitY_EvP(y,y_min,yBG,echelle) ( (y_min) - ( ( ( (double) (y) - (double) (yBG) ) ) * (echelle) ) )

/* -------- Aide pour les styles de dessin -------------- */

void TRC_CouleurSuivante(unsigned int *couleur, unsigned int *style, unsigned int *marque);

/* -------- Sans indication de rgion limitative -------- */

#define TRC_LigneH(fenetre, x0, y0, lg) TRC_Ligne( (fenetre), (x0), (y0), (x0)+((lg)-1), (y0) )
#define TRC_LigneV(fenetre, x0, y0, ht) TRC_Ligne( (fenetre), (x0), (y0), (x0), (y0)+((ht)-1) )

inline void TRC_Message(Fenetre *fenetre, const char *texte);

void TRC_Separateur(Fenetre *fenetre, int sens, int x_debut, int y_debut, int dimension);

/* -------- Avec indication de rgion limitative -------- */

#define TRC_Z_LigneH(fenetre, x_HG, y_HG, largeur, hauteur, x0, y0, lg) TRC_Z_Ligne( (fenetre), (x_HG), (y_HG), (largeur), (hauteur), (x0), (y0), (x0)+(lg), (y0) )
#define TRC_Z_LigneV(fenetre, x_HG, y_HG, largeur, hauteur, x0, y0, ht) TRC_Z_Ligne( (fenetre), (x_HG), (y_HG), (largeur), (hauteur), (x0), (y0), (x0), (y0)+(ht) )

void TRC_Z_Message (Fenetre *fenetre, int x_HG, int y_HG, unsigned int largeur, unsigned int hauteur, const char *texte);

#endif	/* BI_DESSIN_COMMUN_H_ */
