/* Essai de la bib. X
   (C) 1999-2005, Emmanuel CURIS

   Fonctionnement du menu, dans une fentre ventuellement [sous Windows p. ex.].
*/

#include <stdio.h>
#include <stdlib.h>

#include "bib_interface.h"
#include "../exafs.h"

/* -------- Fonction de gestion du menu -------- */

static int gere_menu(unsigned int option)
{
#ifdef ENTREE_FONCTION
  ENTREE_FONCTION( __FUNCTION__, "option=%d", option );
#else
  (void) fprintf(stdout, "%s, %s l.%u : Option = %d\n",
		 __FILE__, __FUNCTION__, __LINE__, option);

#endif

  if ( QUITTER == option ) {
#ifdef SORTIE_FONCTION
    SORTIE_FONCTION( __FUNCTION__, "%d [Quitter]", BI_EVENEMENT_FIN_PRG );
#endif
    return BI_EVENEMENT_FIN_PRG;
  }

  (void) printf("On a cliqu sur l'option : %u\n", option);

#ifdef SORTIE_FONCTION
  SORTIE_FONCTION( __FUNCTION__, "%d [Option quelconque]", BI_EVENEMENT_TRAITE );
#endif
  return BI_EVENEMENT_TRAITE;
}

int main(void)
{
  Fenetre *fenetre;
  boolean sortie = FAUX;
  int retour;

  if ( BI_Initialiser( "../exafs.rsc", 0, NULL, NULL ) == FAUX ) {
    return -1;
  }

  /* On dfinit un menu */
  retour = BI_InstallerMenu( MENU, "Sans titre...", gere_menu );
  if ( retour != 0 ) {
    printf( "Problme  la cration du menu ! [code %d]", retour );
    return -2;
  }

  /* On ouvre une fentre minimaliste */
  fenetre = FEN_NouvelleFenetre( 0, NAME|MOVER|FULLER|SIZER|SMALLER|INFO, NULL );
  if ( NULL == fenetre ) {
    BI_Terminer();
    return -2;
  }

  FEN_titre( fenetre, "Essai de menu" );

  FEN_Ouvrir( fenetre );

  /* On attend que l'utilisateur ait fini ses essais */
  do {
    sortie = BI_AttendEvenement( 0,
				 0, 0, 0, 0, 0, 0UL,
				 NULL, NULL, NULL, NULL, NULL, NULL );
  } while ( sortie != BI_EVENEMENT_FIN_PRG );

  BI_Terminer();
  return 0;
}
