/* Bibliothèque X-Window pour les interfaces
            Routines de gestion des arbres GEM
	    Fichier à inclure
	    Compatible avec gem_gene.c (version GEM : référence)
   (C) 1998, Emmanuel CURIS

 26 mars 1998
   * Création du fichier
*/

#ifndef X_ARBRES_H_

#define X_ARBRES_H_ /* Protection contre l'inclusion multiple */

#include "X_objets.h"

/* --------- Arbre d'objet GEM adapté à X-Window */

typedef struct arbre
{
  OBJECT *adresse;   /* Adresse de la racine de l'arbre considéré */

  union {
    int (*arbre)(unsigned int objet, int x, int y); /* Fonction de gestion de l'arbre */
    int (*menu) (unsigned int option);              /* Cas d'un menu */
  } fonction;
  int (*clavier)(unsigned int touche, int etat, int *renvoi); /* Gestion du clavier */

  unsigned int premier_edit;  /* Premier objet éditable de l'arbre [ROOT : aucun éditable] */
  unsigned int edit_courant;  /* objet éditable actif   de l'arbre [ROOT : idem] */
  unsigned int dernier_edit;  /* Dernier objet éditable de l'arbre [ROOT : idem] */
  unsigned int pos_curseur;   /* Position du curseur dans l'objet éditable courant */
  unsigned int objet_annuler; /* Bouton "Annuler" = UNDO ou fenêtre fermée (ROOT : aucun) */
  unsigned int objet_aide;    /* Bouton "Aide" = HELP ou équivalent (ROOT : aucun)*/
  unsigned int objet_actif;   /* pour l'utilisation de l'arbre par le clavier intégralement... */

  struct {
    unsigned ouvert  : 1; /* VRAI si l'arbre est ouvert */
    unsigned prepare : 1; /* VRAI si l'arbre a déjà été préparé */
    unsigned menu    : 1; /* VRAI : c'est un menu et a déjà été adapté pour être plus joli */
    unsigned interne : 1; /* VRAI : déclaré en interne -> on a fait des strdup divers */
    unsigned init    : 1; /* VRAI : arbre déjà initialisé => coordonnées écran, pas pixel */
    unsigned avec_aide:1; /* VRAI : il y a des textes d'aide associés à l'objet */
  } drapeaux;

  void *complement; /* Pointeur libre pour l'utilisateur */

  const char *URL_aide; /* Où trouver la description de la boîte de dialogue dans la doc [HTML] ? */
  const char **txt_aides; /* Textes d'aide, un par bouton */

  /* -------- Ici, ce qui est en plus pour X-Window -------- */
  unsigned int nbr_objets;  /* Nombre d'objets dans l'arbre */

  Window *objets;  /* objets[i] = index de la fenêtre X qui correspond à l'objet i */
} Arbre;

Arbre *quel_arbre(OBJECT *objet);

#ifdef _LIBRAIRIE_X_
# define BI_NombreArbresInternes (3) /* Trois arbres internes dans la version X :
					- sélecteur de fichier ;
					- menu déroulant ;
					- boîte de dialogue */

unsigned int ARB_QuelObjet(unsigned int num_arbre, Window window);
int          BI_ChangerEditable(Arbre *arbre, unsigned int nv_editable);
int          BI_DessinerCurseur(Arbre *arbre);
int          BI_AvancerCurseur (Arbre *arbre, unsigned int nombre_caracteres);
int          BI_PlacerCurseur  (Arbre *arbre, unsigned int position);
int          BI_ReculerCurseur (Arbre *arbre, unsigned int nombre_caracteres);

int CLIC_arbre(Arbre *arbre, XButtonEvent *souris, unsigned int *bouton);
#endif

#endif /* X_ARBRES_H_ */
