/* Bibliothque X-Window pour les interfaces
   Routines pour les menus (barre de menu et sous-menus "pop-up")

   (C) 1998, Emmanuel CURIS - Cration le 11 septembre 1998
*/

#ifndef X_MENU_

#define X_MENU_ /* vite les inclusions multiples */

#ifdef _LIBRAIRIE_X_ 
# include "X_objets.h"

typedef struct
{
  OBJECT       *adresse;     /* Adresse de l'arbre = menu     */
  Window        racine;      /* Fentre d'affichage du menu   */
  unsigned int  nbr_titres;  /* Nombre de titres dans le menu */
  unsigned int  prem_titre;  /* Index du premier titre dans l'arbre */
  Window       *titres;      /* Les titres des menus */
  unsigned int *prem_option; /* Index de la premire option, pour chaque titre */
  unsigned int *nbr_options; /* Nombre d'options pour chaque titre */
  Window        fond_option; /* Le fond pour ces options */
  Window       *options;     /* Les options du sous-menu droul */
  const char   *titre;       /* Le titre  afficher pour le menu */
  unsigned int option_active;/* Celle en surlignement souris/clavier */

  int (*gestion)(unsigned int option); /* Fonction qui gre le menu [renvoie un BI_EVENEMENT_*] */
} Menu; /* Affichage d'un menu */

int CLIC_menu(Menu *menu, unsigned int num_titre);      /* Clic sur un des titres du menu */
int CLAV_menu(Menu *menu, XKeyEvent *clavier); /* Gestion du clavier, quand le menu est droul */
#endif

int BI_InstallerMenu(unsigned int num_arbre, const char *titre, int (*gestion)(unsigned int option) );
int BI_SupprimerMenu(void);

/* ~-~-~-~-~-~-~-~- Sous-menus droulants ~-~-~-~-~-~-~-~- */

int SS_menu_texte(const char *textes[], unsigned int nbr_txt, const char *titre,
		  int arbre_pere, unsigned int objet_pere);

int GER_ssmenu(unsigned int arbre, unsigned int arbre_pere, unsigned int objet_pere, int delta_y);

#endif /* X_MENU_ */
