/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20141128

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0

#ifndef yyparse
#define yyparse    formulesparse
#endif /* yyparse */

#ifndef yylex
#define yylex      formuleslex
#endif /* yylex */

#ifndef yyerror
#define yyerror    formuleserror
#endif /* yyerror */

#ifndef yychar
#define yychar     formuleschar
#endif /* yychar */

#ifndef yyval
#define yyval      formulesval
#endif /* yyval */

#ifndef yylval
#define yylval     formuleslval
#endif /* yylval */

#ifndef yydebug
#define yydebug    formulesdebug
#endif /* yydebug */

#ifndef yynerrs
#define yynerrs    formulesnerrs
#endif /* yynerrs */

#ifndef yyerrflag
#define yyerrflag  formuleserrflag
#endif /* yyerrflag */

#ifndef yylhs
#define yylhs      formuleslhs
#endif /* yylhs */

#ifndef yylen
#define yylen      formuleslen
#endif /* yylen */

#ifndef yydefred
#define yydefred   formulesdefred
#endif /* yydefred */

#ifndef yydgoto
#define yydgoto    formulesdgoto
#endif /* yydgoto */

#ifndef yysindex
#define yysindex   formulessindex
#endif /* yysindex */

#ifndef yyrindex
#define yyrindex   formulesrindex
#endif /* yyrindex */

#ifndef yygindex
#define yygindex   formulesgindex
#endif /* yygindex */

#ifndef yytable
#define yytable    formulestable
#endif /* yytable */

#ifndef yycheck
#define yycheck    formulescheck
#endif /* yycheck */

#ifndef yyname
#define yyname     formulesname
#endif /* yyname */

#ifndef yyrule
#define yyrule     formulesrule
#endif /* yyrule */
#define YYPREFIX "formules"

#define YYPURE 0

#line 2 "formules.y"
  /* Analyse d'une chane de texte pour en dduire une formule mathmatique
     = relation entre graphes, transformations de coordonnes,...

     (C) 2001 Emmanuel Curis, fichier yacc  l'origine

     Remarque : yacc rsoud les conflits reduce/reduce en choisissant la premire instance
       pour le choix entre 'expr' + 'nombre' et 'expr' + 'expr', on prfre la premire,
       donc on les place en premier [fait un arbre plus simple]

     En particulier, on place en premier le calcul des expressions avec que des nombres,
     comme a le calcul est fait ds l'analyse -> arbre beaucoup plus simple !

     Ceci dit, a n'a pas une grande importance parce que l'arbre cr est toujours correct,
     il sera juste analys diffremment...
  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h> /* Pour tolower() */
#include <math.h>

#include "systeme.h"

#include "c_formel.h"
#include "modeles.h"
#include "science.h"

/* ~~~~~~~~ Variables locales ~~~~~~~~ */

static unsigned long nombre_parametres = 0;
static struct parametre *table_parametres = NULL;

/* ~~~~~~~~ Fonctions locales ~~~~~~~~ */

void yyerror (char *s);

extern char *formulestext; /* Dfinies par lex */
extern int formuleslex(void);
extern struct yy_buffer_state *formules_scan_string(const char *texte);
extern void formules_delete_buffer(struct yy_buffer_state *tampon);

static int       quelle_fonction(char *nom_fonction);
static Variable *CF_TrouverParametre(const char *nom_variable, unsigned long n_parametres, struct parametre *parametres);

static Expression *debut;
#line 50 "formules.y"
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union {
  double nombre;
  char code_variable;
  int code_operation;
  char *nom_fonction;
  Expression *expression;
  Variable *variable;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 164 "y.tab.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define NOMBRE 257
#define VARIABLE 258
#define OPERATION 259
#define FONCTION 260
#define NEG 261
#define YYERRCODE 256
typedef short YYINT;
static const YYINT formuleslhs[] = {                     -1,
    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    3,    3,    3,    3,    3,    3,    3,    3,    4,    4,
    4,    4,    4,    4,    4,    4,    5,    5,    5,    5,
    5,    5,    5,    5,    6,    6,    6,    6,    6,    6,
    6,    6,    7,    7,    7,    7,    7,    7,    7,    7,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    8,    8,
};
static const YYINT formuleslen[] = {                      2,
    1,    3,    3,    3,    3,    3,    3,    2,    1,    4,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    4,    4,    1,    1,    1,    1,    1,    1,    2,
    1,    1,    1,
};
static const YYINT formulesdefred[] = {                   0,
    9,   62,    0,    0,    0,    0,    0,    0,   54,   55,
   56,   57,   58,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    2,   51,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   10,   53,   52,
};
static const YYINT formulesdgoto[] = {                    6,
    7,    8,    9,   10,   11,   12,   13,   14,
};
static const YYINT formulessindex[] = {                 -40,
    0,    0,  -33,  -40,  -40,    0,    7,   14,    0,    0,
    0,    0,    0,   21,  -40,  -80,  -75,  -39,  -32,  -40,
  -40,  -40,  -40,  -40,  -40,  -40,  -40,  -40,  -40,  -40,
  -40,  -40,  -40,  -40,  -25,  -18,  -11,    0,    0,  -21,
  -14,   -7,  -21,  -14,   -7,  -80,  -75,  -57,  -80,  -75,
  -57,  -80,  -75,  -57,  -21,  -14,   -7,  -21,  -14,   -7,
  -80,  -75,  -57,  -80,  -75,  -57,  -80,  -75,  -57,  -21,
  -14,   -7,  -21,  -14,   -7,  -80,  -75,  -57,  -80,  -75,
  -57,  -80,  -75,  -57,    0,    0,    0,
};
static const YYINT formulesrindex[] = {                   0,
    0,    0,    1,    0,    0,    0,   38,   39,    0,    0,
    0,    0,    0,   12,    0,   47,   71,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   41,
  285,  293,  300,  307,  315,   78,   85,   93,  100,  107,
  117,  124,  131,  139,  322,  327,  332,  333,  339,  340,
  146,  153,  161,  168,  183,  190,  197,  205,  212,  346,
  347,  353,  354,  359,  362,  219,  227,  234,  241,  249,
  256,  263,  271,  278,    0,    0,    0,
};
static const YYINT formulesgindex[] = {                   0,
  404,  435,    0,    0,    0,    0,    0,  455,
};
#define YYTABLESIZE 489
static const YYINT formulestable[] = {                    5,
   63,   38,   22,   21,    4,   20,   15,   23,   39,   27,
   26,   61,   25,   24,   28,   85,   22,   21,   29,   20,
   22,   23,   86,   27,   26,   23,   25,   27,   28,   87,
   32,   31,   28,   30,   32,   33,   34,   59,    1,   33,
    4,   63,   63,   63,    0,   63,    8,   63,   22,   21,
    0,   20,   61,   23,   24,   27,   26,    0,   25,    0,
   28,   29,   32,   31,    0,   30,    0,   33,   24,    0,
   60,    0,   24,    0,    0,   29,    0,    5,    0,   29,
    0,    4,   34,    4,   30,    4,   34,    8,    8,    8,
    0,    8,   27,    8,   63,    0,    0,    0,    0,    6,
   24,    0,    0,    0,    0,    0,   38,   29,    0,    0,
    0,   60,   60,   60,   34,   60,   35,   60,    5,    5,
    5,    0,    5,    7,    5,   30,   30,   30,    0,   30,
   46,   30,    0,   27,   27,   27,    0,   27,   43,   27,
    6,    6,    6,    0,    6,   32,    6,   38,   38,   38,
    0,   38,   34,   38,    0,    0,    0,   35,   35,   35,
   33,   35,    0,   35,    7,    7,    7,   40,    7,    0,
    7,   46,   46,   46,    0,   46,    0,   46,    0,   43,
   43,   43,   42,   43,    0,   43,   32,   32,   32,   41,
   32,    0,   32,   34,   34,   34,   48,   34,    0,   34,
    0,   33,   33,   33,   50,   33,    0,   33,   40,   40,
   40,   49,   40,    0,   40,    0,    1,    2,   28,    3,
    0,    0,    0,   42,   42,   42,   31,   42,    0,   42,
   41,   41,   41,   29,   41,    0,   41,   48,   48,   48,
   36,   48,    0,   48,    0,   50,   50,   50,   39,   50,
    0,   50,   49,   49,   49,   37,   49,    0,   49,   28,
   28,   28,   44,   28,    0,   28,    0,   31,   31,   31,
   47,   31,    0,   31,   29,   29,   29,   45,   29,    0,
   29,   36,   36,   36,   22,   36,    0,   36,    0,   39,
   39,   39,   19,   39,    0,   39,   37,   37,   37,    3,
   37,    0,   37,   44,   44,   44,   14,   44,    0,   44,
    0,   47,   47,   47,   11,   47,    0,   47,   45,   45,
   45,   24,   45,    0,   45,   22,   26,   22,    0,   22,
    0,   25,   16,   19,    0,   19,    0,   19,   18,   17,
    3,    0,    3,    0,    3,   20,   23,   14,    0,   14,
    0,   14,   21,   12,    0,   11,    0,   11,   15,   11,
    0,   13,   24,    0,   24,    0,   24,   26,    0,   26,
    0,   26,   25,   16,   25,   16,   25,   16,    0,   18,
   17,   18,   17,   18,   17,    0,   20,   23,   20,   23,
   20,   23,    0,   21,   12,   21,   12,   21,   12,   15,
    0,   15,   13,   15,   13,    0,   13,   16,   18,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   35,    0,
    0,    0,    0,   40,   43,   46,   49,   52,   55,   58,
   61,   64,   67,   70,   73,   76,   79,   82,   17,   19,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   36,
    0,    0,    0,    0,   41,   44,   47,   50,   53,   56,
   59,   62,   65,   68,   71,   74,   77,   80,   83,   37,
    0,    0,    0,    0,   42,   45,   48,   51,   54,   57,
   60,   63,   66,   69,   72,   75,   78,   81,   84,
};
static const YYINT formulescheck[] = {                   40,
    0,   41,   42,   43,   45,   45,   40,   47,   41,   42,
   43,    0,   45,   94,   47,   41,   42,   43,   94,   45,
   42,   47,   41,   42,   43,   47,   45,   42,   47,   41,
   42,   43,   47,   45,   42,   47,   94,    0,    0,   47,
    0,   41,   42,   43,   -1,   45,    0,   47,   42,   43,
   -1,   45,   41,   47,   94,   42,   43,   -1,   45,   -1,
   47,   94,   42,   43,   -1,   45,   -1,   47,   94,   -1,
    0,   -1,   94,   -1,   -1,   94,   -1,    0,   -1,   94,
   -1,   41,   94,   43,    0,   45,   94,   41,   42,   43,
   -1,   45,    0,   47,   94,   -1,   -1,   -1,   -1,    0,
   94,   -1,   -1,   -1,   -1,   -1,    0,   94,   -1,   -1,
   -1,   41,   42,   43,   94,   45,    0,   47,   41,   42,
   43,   -1,   45,    0,   47,   41,   42,   43,   -1,   45,
    0,   47,   -1,   41,   42,   43,   -1,   45,    0,   47,
   41,   42,   43,   -1,   45,    0,   47,   41,   42,   43,
   -1,   45,    0,   47,   -1,   -1,   -1,   41,   42,   43,
    0,   45,   -1,   47,   41,   42,   43,    0,   45,   -1,
   47,   41,   42,   43,   -1,   45,   -1,   47,   -1,   41,
   42,   43,    0,   45,   -1,   47,   41,   42,   43,    0,
   45,   -1,   47,   41,   42,   43,    0,   45,   -1,   47,
   -1,   41,   42,   43,    0,   45,   -1,   47,   41,   42,
   43,    0,   45,   -1,   47,   -1,  257,  258,    0,  260,
   -1,   -1,   -1,   41,   42,   43,    0,   45,   -1,   47,
   41,   42,   43,    0,   45,   -1,   47,   41,   42,   43,
    0,   45,   -1,   47,   -1,   41,   42,   43,    0,   45,
   -1,   47,   41,   42,   43,    0,   45,   -1,   47,   41,
   42,   43,    0,   45,   -1,   47,   -1,   41,   42,   43,
    0,   45,   -1,   47,   41,   42,   43,    0,   45,   -1,
   47,   41,   42,   43,    0,   45,   -1,   47,   -1,   41,
   42,   43,    0,   45,   -1,   47,   41,   42,   43,    0,
   45,   -1,   47,   41,   42,   43,    0,   45,   -1,   47,
   -1,   41,   42,   43,    0,   45,   -1,   47,   41,   42,
   43,    0,   45,   -1,   47,   41,    0,   43,   -1,   45,
   -1,    0,    0,   41,   -1,   43,   -1,   45,    0,    0,
   41,   -1,   43,   -1,   45,    0,    0,   41,   -1,   43,
   -1,   45,    0,    0,   -1,   41,   -1,   43,    0,   45,
   -1,    0,   41,   -1,   43,   -1,   45,   41,   -1,   43,
   -1,   45,   41,   41,   43,   43,   45,   45,   -1,   41,
   41,   43,   43,   45,   45,   -1,   41,   41,   43,   43,
   45,   45,   -1,   41,   41,   43,   43,   45,   45,   41,
   -1,   43,   41,   45,   43,   -1,   45,    4,    5,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   15,   -1,
   -1,   -1,   -1,   20,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,   33,   34,    4,    5,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   15,
   -1,   -1,   -1,   -1,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   15,
   -1,   -1,   -1,   -1,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,
};
#define YYFINAL 6
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 261
#define YYUNDFTOKEN 272
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const formulesname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'",0,"'-'",0,"'/'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'^'",0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"NOMBRE","VARIABLE","OPERATION","FONCTION","NEG",0,0,0,0,0,0,0,0,0,0,
"illegal-symbol",
};
static const char *const formulesrule[] = {
"$accept : lancement",
"lancement : relation",
"exp_numerique : '(' exp_numerique ')'",
"exp_numerique : exp_numerique '+' exp_numerique",
"exp_numerique : exp_numerique '-' exp_numerique",
"exp_numerique : exp_numerique '*' exp_numerique",
"exp_numerique : exp_numerique '/' exp_numerique",
"exp_numerique : exp_numerique '^' exp_numerique",
"exp_numerique : '-' exp_numerique",
"exp_numerique : NOMBRE",
"exp_numerique : FONCTION '(' exp_numerique ')'",
"addition : exp_numerique '+' def_variable",
"addition : def_variable '+' exp_numerique",
"addition : def_variable '+' def_variable",
"addition : exp_numerique '+' relation",
"addition : def_variable '+' relation",
"addition : relation '+' exp_numerique",
"addition : relation '+' def_variable",
"addition : relation '+' relation",
"difference : exp_numerique '-' def_variable",
"difference : def_variable '-' exp_numerique",
"difference : def_variable '-' def_variable",
"difference : exp_numerique '-' relation",
"difference : def_variable '-' relation",
"difference : relation '-' exp_numerique",
"difference : relation '-' def_variable",
"difference : relation '-' relation",
"produit : exp_numerique '*' def_variable",
"produit : def_variable '*' exp_numerique",
"produit : def_variable '*' def_variable",
"produit : exp_numerique '*' relation",
"produit : def_variable '*' relation",
"produit : relation '*' exp_numerique",
"produit : relation '*' def_variable",
"produit : relation '*' relation",
"quotient : exp_numerique '/' def_variable",
"quotient : def_variable '/' exp_numerique",
"quotient : def_variable '/' def_variable",
"quotient : exp_numerique '/' relation",
"quotient : def_variable '/' relation",
"quotient : relation '/' exp_numerique",
"quotient : relation '/' def_variable",
"quotient : relation '/' relation",
"puissance : exp_numerique '^' def_variable",
"puissance : def_variable '^' exp_numerique",
"puissance : def_variable '^' def_variable",
"puissance : exp_numerique '^' relation",
"puissance : def_variable '^' relation",
"puissance : relation '^' exp_numerique",
"puissance : relation '^' def_variable",
"puissance : relation '^' relation",
"relation : '(' relation ')'",
"relation : FONCTION '(' def_variable ')'",
"relation : FONCTION '(' relation ')'",
"relation : addition",
"relation : difference",
"relation : produit",
"relation : quotient",
"relation : puissance",
"relation : exp_numerique",
"relation : '-' relation",
"relation : def_variable",
"def_variable : VARIABLE",
"def_variable : FONCTION",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 712 "formules.y"

#ifdef _DEVELOPPE_

static void aff_operation(int code, unsigned int delta)
{
  unsigned int i;

  for (i = 0 ; i < delta ; i++)
    printf("| ");

  switch (code)
  {
  case EXP_NOMBRE_ISOLE: printf("|on ignore le 2e lment"); break;
  case EXP_ADDITION:     printf("+"); break;
  case EXP_SOUSTRACTION: printf("-"); break;
  case EXP_PRODUIT:      printf("*"); break;
  case EXP_DIVISION:     printf("/"); break;

  case EXP_COSINUS: printf("cos()"); break;
  case EXP_SINUS: printf("sin()"); break;
  case EXP_TANGENTE: printf("tg()"); break;
  case EXP_COSH: printf("ch()"); break;
  case EXP_SINH: printf("sh()"); break;
  case EXP_TANH: printf("th()"); break;

  case EXP_EXP:   printf("exp()"); break;
  case EXP_EXP10: printf("exp10()"); break;
  case EXP_LOG:   printf("log()"); break;
  case EXP_LOG10: printf("log10()"); break;
  }
  printf("\n");
}

static void aff_noeud(Expression *noeud, unsigned int delta)
{
  unsigned int i;

  if (noeud == NULL)
    return;

  /* On s'occupe de l'indentation */
  if (delta > 0) {
    for (i = 0 ; i < delta - 1 ; i++)
      printf("| ");
    printf("|-");
  }

  printf("Noeud de type %d, code %d\n", noeud->type, noeud->code);
  if (noeud->type == EXP_CTE_CTE) {
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    printf("|-> Valeur = %f\n", noeud->arg_1.valeur);
    aff_operation(noeud->code, delta);
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    printf("|-> Valeur = %f\n", noeud->arg_2.valeur);   
  } else if (noeud->type == EXP_CTE_ARG) {
    printf("|-> Valeur = %f\n", noeud->arg_1.valeur);
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    aff_operation(noeud->code, delta);
    aff_noeud(noeud->arg_2.expression, delta + 1);
  } else if (noeud->type == EXP_ARG_CTE) {
    aff_noeud(noeud->arg_1.expression, delta + 1);
    aff_operation(noeud->code, delta);
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    printf("|-> Valeur = %f\n", noeud->arg_2.valeur);
  } else if (noeud->type == EXP_ARG_ARG) {
    aff_noeud(noeud->arg_1.expression, delta + 1);
    aff_operation(noeud->code, delta);
    aff_noeud(noeud->arg_2.expression, delta + 1);
  } else if (noeud->type == EXP_CTE_VAR) {
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    printf("|-> Valeur = %f\n", noeud->arg_1.valeur);   
    aff_operation(noeud->code, delta);
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    printf("|-> Variable [%p : %g = %g, type %d]\n", (void *) noeud->arg_2.variable, noeud->arg_2.variable->valeur_initiale, VAR_prend_valeur( noeud->arg_2.variable ), noeud->arg_2.variable->type);
  } else if (noeud->type == EXP_VAR_CTE) {
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    printf("|-> Variable [%p : %g = %g, type %d]\n", (void *) noeud->arg_1.variable, noeud->arg_1.variable->valeur_initiale, VAR_prend_valeur( noeud->arg_1.variable ), noeud->arg_1.variable->type);
    aff_operation(noeud->code, delta);
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    printf("|-> Valeur = %f\n", noeud->arg_2.valeur);   
  } else if (noeud->type == EXP_VAR_VAR) {
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    printf("|-> Variable [%p : %g = %g, type %d]\n", (void *) noeud->arg_1.variable, noeud->arg_1.variable->valeur_initiale, VAR_prend_valeur( noeud->arg_1.variable ), noeud->arg_1.variable->type);
    aff_operation(noeud->code, delta);
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    printf("|-> Variable [%p : %g = %g, type %d]\n", (void *) noeud->arg_2.variable, noeud->arg_2.variable->valeur_initiale, VAR_prend_valeur( noeud->arg_2.variable ), noeud->arg_2.variable->type);
  } else if (noeud->type == EXP_ARG_VAR) {
    aff_noeud(noeud->arg_1.expression, delta + 1);
    aff_operation(noeud->code, delta);
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    printf("|-> Variable [%p : %g = %g, type %d]\n", (void *) noeud->arg_2.variable, noeud->arg_2.variable->valeur_initiale, VAR_prend_valeur( noeud->arg_2.variable ), noeud->arg_2.variable->type);
  } else if (noeud->type == EXP_VAR_ARG) {
    for (i = 0 ; i < delta ; i++)
      printf("| ");
    printf("|-> Variable [%p : %g = %g, type %d]\n", (void *) noeud->arg_1.variable, noeud->arg_1.variable->valeur_initiale, VAR_prend_valeur( noeud->arg_1.variable ), noeud->arg_1.variable->type);
    aff_operation(noeud->code, delta);
    aff_noeud(noeud->arg_2.expression, delta + 1);
  }
}

#endif

static int quelle_fonction(char *nom_fonction)
{
  size_t i;

  if (nom_fonction == NULL) {
    return EXP_INDEFINIE;
  }

  /* On commence par convertir en minuscules */
  for (i = 0 ; i < strlen(nom_fonction) ; i++) {
    nom_fonction[i] = tolower( nom_fonction[i] );
  }
#ifdef _DEVELOPPE_
  printf("Fonction  chercher : %s\n", nom_fonction);
#endif

  /* On compare aux fonctions connues */
  if (strcmp(nom_fonction, "log") == 0)
    return EXP_LOG;
  if (strcmp(nom_fonction, "log10") == 0)
    return EXP_LOG10;
  if (strcmp(nom_fonction, "exp") == 0)
    return EXP_EXP;
  if (strcmp(nom_fonction, "exp10") == 0)
    return EXP_EXP10;
  if (strcmp(nom_fonction, "cos") == 0)
    return EXP_COSINUS;
  if (strcmp(nom_fonction, "sin") == 0)
    return EXP_SINUS;
  if ( (strcmp(nom_fonction, "tan") == 0) || (strcmp(nom_fonction, "tg") == 0) )
    return EXP_TANGENTE;
  if ( (strcmp(nom_fonction, "cosh") == 0) || (strcmp(nom_fonction, "ch") == 0) )
    return EXP_COSH;
  if ( (strcmp(nom_fonction, "sinh") == 0) || (strcmp(nom_fonction, "sh") == 0) )
    return EXP_SINH;
  if ( (strcmp(nom_fonction, "tanh") == 0) || (strcmp(nom_fonction, "th") == 0) )
    return EXP_TANH;
  if ( strcmp( nom_fonction, "LW" ) == 0 )
    return EXP_LAMBERTW0;

  return EXP_INDEFINIE;
}

static Variable *CF_TrouverParametre(const char *nom_variable, unsigned long n_parametres, struct parametre *parametres)
{
  unsigned int i;

  if ( NULL == nom_variable ) return NULL;
  if ( ( 0 == n_parametres ) || ( NULL == parametres ) ) {
    /* Aucune variable utilisateur */
    return NULL;
  }

  for ( i = 0 ; i < n_parametres ; i++ ) {
    if ( strcmp( nom_variable, parametres[ i ].symbole ) == 0 ) {
      return &(parametres[ i ].variable);
    }
  }

  /* Variable non trouve */
  return NULL;
}

#ifdef _ISOLE_
int main(void)
{
  debut = NULL;
  yyparse();

  aff_noeud(debut, 0);


  return 0;
}
#else
Expression *construit_arbre(const char *formule)
{
  struct yy_buffer_state *tampon_flex;

  if (formule == NULL) return NULL;

  debut = NULL;
  tampon_flex = formules_scan_string( formule );
  formulesparse();
  formules_delete_buffer(tampon_flex);

#ifdef _DEVELOPPE_
  aff_noeud(debut, 0);
#endif

  return debut;
}

/* -------- Analyse d'une formule, pouvant comprendre des paramtres -------- */

Expression *CF_ConstruireArbre(const char *formule, unsigned long n_parametres, struct parametre *parametres)
{
  Expression *arbre;

  /* Contrle prliminaire */
  if ( NULL == formule ) {
    (void) fprintf(stderr, "%s, %s l.%u : Aucune formule indique !\n",
		   __FILE__, __FUNCTION__, __LINE__);
    return NULL;
  }

  /* On mmorise la table des paramtres */
  if ( n_parametres > 0 ) {
    if ( nombre_parametres > 0 ) {
      (void) fprintf(stderr, "%s, %s l.%u : Une table de paramtres existe dj : il y a donc une analyse en cours\n",
		     __FILE__, __FUNCTION__, __LINE__);
      return NULL;
    }

    nombre_parametres = n_parametres;
    table_parametres = parametres; 
  }

  /* On analyse la formule */
  arbre = construit_arbre( formule );

  /* On libre la table de paramtres */
  table_parametres = NULL;
  nombre_parametres = 0;

  /* On a termin : on renvoie l'arbre */
  return arbre;
}

#endif

void yyerror (char *s)
{
  fprintf (stderr, "%s\n", s);
#ifdef _DEVELOPPE_
  aff_noeud( debut, 0 );
#endif
}
#line 738 "y.tab.c"

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            yys = yyname[YYTRANSLATE(yychar)];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = yyname[YYTRANSLATE(yychar)];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 1:
#line 75 "formules.y"
	{ debut = yystack.l_mark[0].expression; }
break;
case 2:
#line 78 "formules.y"
	{ yyval.nombre = yystack.l_mark[-1].nombre; }
break;
case 3:
#line 79 "formules.y"
	{yyval.nombre = yystack.l_mark[-2].nombre + yystack.l_mark[0].nombre;}
break;
case 4:
#line 80 "formules.y"
	{yyval.nombre = yystack.l_mark[-2].nombre - yystack.l_mark[0].nombre;}
break;
case 5:
#line 81 "formules.y"
	{yyval.nombre = yystack.l_mark[-2].nombre * yystack.l_mark[0].nombre;}
break;
case 6:
#line 82 "formules.y"
	{yyval.nombre = yystack.l_mark[-2].nombre / yystack.l_mark[0].nombre;}
break;
case 7:
#line 83 "formules.y"
	{yyval.nombre = pow(yystack.l_mark[-2].nombre, yystack.l_mark[0].nombre);}
break;
case 8:
#line 84 "formules.y"
	{yyval.nombre = -yystack.l_mark[0].nombre;}
break;
case 9:
#line 85 "formules.y"
	{yyval.nombre = yystack.l_mark[0].nombre;}
break;
case 10:
#line 86 "formules.y"
	{
	                                        int code_fonction;

						code_fonction = quelle_fonction(yystack.l_mark[-3].nom_fonction);
						switch(code_fonction)
						{
						case EXP_SINUS:   yyval.nombre = sin(yystack.l_mark[-1].nombre); break;
						case EXP_COSINUS: yyval.nombre = cos(yystack.l_mark[-1].nombre); break;
						case EXP_TANGENTE:yyval.nombre = tan(yystack.l_mark[-1].nombre); break;
						case EXP_COTANGENTE: yyval.nombre = 1.0/tan(yystack.l_mark[-1].nombre); break;
						case EXP_SECANTE: yyval.nombre = 1.0/cos(yystack.l_mark[-1].nombre); break;
						case EXP_COSECANTE: yyval.nombre = 1.0/sin(yystack.l_mark[-1].nombre); break;

						case EXP_COSH: yyval.nombre = cosh(yystack.l_mark[-1].nombre); break;
						case EXP_SINH: yyval.nombre = sinh(yystack.l_mark[-1].nombre); break;
						case EXP_TANH: yyval.nombre = tanh(yystack.l_mark[-1].nombre); break;

						case EXP_EXP:     yyval.nombre = exp(yystack.l_mark[-1].nombre); break;
						case EXP_LOG:     yyval.nombre = log(yystack.l_mark[-1].nombre); break;

						case EXP_RACINE: yyval.nombre = sqrt(yystack.l_mark[-1].nombre); break;
						case EXP_CARRE: yyval.nombre = yystack.l_mark[-1].nombre * yystack.l_mark[-1].nombre; break;
						case EXP_CUBE: yyval.nombre = yystack.l_mark[-1].nombre * yystack.l_mark[-1].nombre * yystack.l_mark[-1].nombre; break;
						case EXP_INVERSE: yyval.nombre = 1.0/yystack.l_mark[-1].nombre; break;
						}
	                                      }
break;
case 11:
#line 114 "formules.y"
	{ Expression *nv_expression;
	                                   nv_expression = (Expression *) malloc(sizeof(Expression));
					   if (nv_expression == NULL) {
					     yyerror("Mmoire insuffisante\n");
					   }
					   nv_expression->type = EXP_VAR_CTE;
					   nv_expression->code = EXP_ADDITION;
					   nv_expression->arg_1.variable = yystack.l_mark[0].variable;
					   nv_expression->arg_2.valeur = yystack.l_mark[-2].nombre;
					   yyval.expression = nv_expression;
                                         }
break;
case 12:
#line 126 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_CTE;
				      nv_expression->code = EXP_ADDITION;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.valeur = yystack.l_mark[0].nombre;
				      yyval.expression = nv_expression;
	                        }
break;
case 13:
#line 138 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_VAR;
				      nv_expression->code = EXP_ADDITION;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.variable = yystack.l_mark[0].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 14:
#line 150 "formules.y"
	{ Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       nv_expression->type = EXP_ARG_CTE;
				       nv_expression->code = EXP_ADDITION;
				       nv_expression->arg_1.expression = yystack.l_mark[0].expression;
				       nv_expression->arg_2.valeur = yystack.l_mark[-2].nombre;
				       yyval.expression = nv_expression;
	                             }
break;
case 15:
#line 162 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_ARG_VAR;
				      nv_expression->code = EXP_ADDITION;
				      nv_expression->arg_1.expression = yystack.l_mark[0].expression;
				      nv_expression->arg_2.variable = yystack.l_mark[-2].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 16:
#line 175 "formules.y"
	{ Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       nv_expression->type = EXP_ARG_CTE;
				       nv_expression->code = EXP_ADDITION;
				       nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				       nv_expression->arg_2.valeur = yystack.l_mark[0].nombre;
				       yyval.expression = nv_expression;
	                             }
break;
case 17:
#line 187 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_ARG_VAR;
				      nv_expression->code = EXP_ADDITION;
				      nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				      nv_expression->arg_2.variable = yystack.l_mark[0].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 18:
#line 199 "formules.y"
	{ Expression *nv_expression;
	                          nv_expression = (Expression *) malloc(sizeof(Expression));
				  if (nv_expression == NULL) {
				    yyerror("Mmoire insuffisante\n");
				  }
				  nv_expression->type = EXP_ARG_ARG;
				  nv_expression->code = EXP_ADDITION;
				  nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				  nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				  yyval.expression = nv_expression;
	                         }
break;
case 19:
#line 212 "formules.y"
	{ Expression *nv_expression;
	                                   nv_expression = (Expression *) malloc(sizeof(Expression));
					   if (nv_expression == NULL) {
					     yyerror("Mmoire insuffisante\n");
					   }
					   nv_expression->type = EXP_CTE_VAR;
					   nv_expression->code = EXP_SOUSTRACTION;
					   nv_expression->arg_1.valeur = yystack.l_mark[-2].nombre;
					   nv_expression->arg_2.variable = yystack.l_mark[0].variable;
					   yyval.expression = nv_expression;
                                         }
break;
case 20:
#line 224 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_CTE;
				      nv_expression->code = EXP_SOUSTRACTION;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.valeur = yystack.l_mark[0].nombre;
				      yyval.expression = nv_expression;
	                        }
break;
case 21:
#line 236 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_VAR;
				      nv_expression->code = EXP_SOUSTRACTION;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.variable = yystack.l_mark[0].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 22:
#line 248 "formules.y"
	{ Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       nv_expression->type = EXP_CTE_ARG;
				       nv_expression->code = EXP_SOUSTRACTION;
				       nv_expression->arg_1.valeur = yystack.l_mark[-2].nombre;
				       nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				       yyval.expression = nv_expression;
	                             }
break;
case 23:
#line 260 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_ARG;
				      nv_expression->code = EXP_SOUSTRACTION;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				      yyval.expression = nv_expression;
	                        }
break;
case 24:
#line 272 "formules.y"
	{ Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       nv_expression->type = EXP_ARG_CTE;
				       nv_expression->code = EXP_SOUSTRACTION;
				       nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				       nv_expression->arg_2.valeur = yystack.l_mark[0].nombre;
				       yyval.expression = nv_expression;
	                             }
break;
case 25:
#line 284 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_ARG_VAR;
				      nv_expression->code = EXP_SOUSTRACTION;
				      nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				      nv_expression->arg_2.variable = yystack.l_mark[0].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 26:
#line 296 "formules.y"
	{ Expression *nv_expression;
	                          nv_expression = (Expression *) malloc(sizeof(Expression));
				  if (nv_expression == NULL) {
				    yyerror("Mmoire insuffisante\n");
				  }
				  nv_expression->type = EXP_ARG_ARG;
				  nv_expression->code = EXP_SOUSTRACTION;
				  nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				  nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				  yyval.expression = nv_expression;
	                         }
break;
case 27:
#line 309 "formules.y"
	{ Expression *nv_expression;
	                                   nv_expression = (Expression *) malloc(sizeof(Expression));
					   if (nv_expression == NULL) {
					     yyerror("Mmoire insuffisante\n");
					   }
					   nv_expression->type = EXP_VAR_CTE;
					   nv_expression->code = EXP_PRODUIT;
					   nv_expression->arg_1.variable = yystack.l_mark[0].variable;
					   nv_expression->arg_2.valeur = yystack.l_mark[-2].nombre;
					   yyval.expression = nv_expression;
                                         }
break;
case 28:
#line 321 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_CTE;
				      nv_expression->code = EXP_PRODUIT;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.valeur = yystack.l_mark[0].nombre;
				      yyval.expression = nv_expression;
	                        }
break;
case 29:
#line 333 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_VAR;
				      nv_expression->code = EXP_PRODUIT;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.variable = yystack.l_mark[0].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 30:
#line 345 "formules.y"
	{ Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       nv_expression->type = EXP_ARG_CTE;
				       nv_expression->code = EXP_PRODUIT;
				       nv_expression->arg_1.expression = yystack.l_mark[0].expression;
				       nv_expression->arg_2.valeur = yystack.l_mark[-2].nombre;
				       yyval.expression = nv_expression;
	                             }
break;
case 31:
#line 357 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_ARG_VAR;
				      nv_expression->code = EXP_PRODUIT;
				      nv_expression->arg_1.expression = yystack.l_mark[0].expression;
				      nv_expression->arg_2.variable = yystack.l_mark[-2].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 32:
#line 369 "formules.y"
	{ Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       nv_expression->type = EXP_ARG_CTE;
				       nv_expression->code = EXP_PRODUIT;
				       nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				       nv_expression->arg_2.valeur = yystack.l_mark[0].nombre;
				       yyval.expression = nv_expression;
	                             }
break;
case 33:
#line 381 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_ARG_VAR;
				      nv_expression->code = EXP_PRODUIT;
				      nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				      nv_expression->arg_2.variable = yystack.l_mark[0].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 34:
#line 393 "formules.y"
	{ Expression *nv_expression;
	                          nv_expression = (Expression *) malloc(sizeof(Expression));
				  if (nv_expression == NULL) {
				    yyerror("Mmoire insuffisante\n");
				  }
				  nv_expression->type = EXP_ARG_ARG;
				  nv_expression->code = EXP_PRODUIT;
				  nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				  nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				  yyval.expression = nv_expression;
	                         }
break;
case 35:
#line 406 "formules.y"
	{ Expression *nv_expression;
	                                   nv_expression = (Expression *) malloc(sizeof(Expression));
					   if (nv_expression == NULL) {
					     yyerror("Mmoire insuffisante\n");
					   }
					   nv_expression->type = EXP_CTE_VAR;
					   nv_expression->code = EXP_DIVISION;
					   nv_expression->arg_1.valeur = yystack.l_mark[-2].nombre;
					   nv_expression->arg_2.variable = yystack.l_mark[0].variable;
					   yyval.expression = nv_expression;
                                         }
break;
case 36:
#line 418 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_CTE;
				      nv_expression->code = EXP_DIVISION;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.valeur = yystack.l_mark[0].nombre;
				      yyval.expression = nv_expression;
	                        }
break;
case 37:
#line 430 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_VAR;
				      nv_expression->code = EXP_DIVISION;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.variable = yystack.l_mark[0].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 38:
#line 442 "formules.y"
	{ Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       nv_expression->type = EXP_CTE_ARG;
				       nv_expression->code = EXP_DIVISION;
				       nv_expression->arg_1.valeur = yystack.l_mark[-2].nombre;
				       nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				       yyval.expression = nv_expression;
	                             }
break;
case 39:
#line 454 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_ARG;
				      nv_expression->code = EXP_DIVISION;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				      yyval.expression = nv_expression;
	                        }
break;
case 40:
#line 466 "formules.y"
	{ Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       nv_expression->type = EXP_ARG_CTE;
				       nv_expression->code = EXP_DIVISION;
				       nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				       nv_expression->arg_2.valeur = yystack.l_mark[0].nombre;
				       yyval.expression = nv_expression;
	                             }
break;
case 41:
#line 478 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_ARG_VAR;
				      nv_expression->code = EXP_DIVISION;
				      nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				      nv_expression->arg_2.variable = yystack.l_mark[0].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 42:
#line 490 "formules.y"
	{ Expression *nv_expression;
	                          nv_expression = (Expression *) malloc(sizeof(Expression));
				  if (nv_expression == NULL) {
				    yyerror("Mmoire insuffisante\n");
				  }
				  nv_expression->type = EXP_ARG_ARG;
				  nv_expression->code = EXP_DIVISION;
				  nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				  nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				  yyval.expression = nv_expression;
	                         }
break;
case 43:
#line 503 "formules.y"
	{ Expression *nv_expression;
	                                    nv_expression = (Expression *) malloc(sizeof(Expression));
					    if (nv_expression == NULL) {
					      yyerror("Mmoire insuffisante\n");
					    }
					    nv_expression->type = EXP_CTE_VAR;
					    nv_expression->code = EXP_PUISSANCE;
					    nv_expression->arg_1.valeur = yystack.l_mark[-2].nombre;
					    nv_expression->arg_2.variable = yystack.l_mark[0].variable;
					    yyval.expression = nv_expression;
                                          }
break;
case 44:
#line 515 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_CTE;
				      nv_expression->code = EXP_PUISSANCE;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.valeur = yystack.l_mark[0].nombre;
				      yyval.expression = nv_expression;
	                        }
break;
case 45:
#line 527 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_VAR;
				      nv_expression->code = EXP_PUISSANCE;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.variable = yystack.l_mark[0].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 46:
#line 539 "formules.y"
	{ Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       nv_expression->type = EXP_CTE_ARG;
				       nv_expression->code = EXP_PUISSANCE;
				       nv_expression->arg_1.valeur = yystack.l_mark[-2].nombre;
				       nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				       yyval.expression = nv_expression;
	                             }
break;
case 47:
#line 551 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_VAR_ARG;
				      nv_expression->code = EXP_PUISSANCE;
				      nv_expression->arg_1.variable = yystack.l_mark[-2].variable;
				      nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				      yyval.expression = nv_expression;
	                        }
break;
case 48:
#line 563 "formules.y"
	{ Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       OPTION_A_FAIRE( "Grer le cas du carr et du cube pour calcul plus rapide !" );
				       nv_expression->type = EXP_ARG_CTE;
				       nv_expression->code = EXP_PUISSANCE;
				       nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				       nv_expression->arg_2.valeur = yystack.l_mark[0].nombre;
				       yyval.expression = nv_expression;
	                             }
break;
case 49:
#line 576 "formules.y"
	{ Expression *nv_expression;
	                              nv_expression = (Expression *) malloc(sizeof(Expression));
				      if (nv_expression == NULL) {
					yyerror("Mmoire insuffisante\n");
				      }
				      nv_expression->type = EXP_ARG_VAR;
				      nv_expression->code = EXP_PUISSANCE;
				      nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				      nv_expression->arg_2.variable = yystack.l_mark[0].variable;
				      yyval.expression = nv_expression;
	                        }
break;
case 50:
#line 588 "formules.y"
	{ Expression *nv_expression;
	                          nv_expression = (Expression *) malloc(sizeof(Expression));
				  if (nv_expression == NULL) {
				    yyerror("Mmoire insuffisante\n");
				  }
				  nv_expression->type = EXP_ARG_ARG;
				  nv_expression->code = EXP_PUISSANCE;
				  nv_expression->arg_1.expression = yystack.l_mark[-2].expression;
				  nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				  yyval.expression = nv_expression;
	                         }
break;
case 51:
#line 601 "formules.y"
	{ yyval.expression = yystack.l_mark[-1].expression; }
break;
case 52:
#line 603 "formules.y"
	{  Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       /* Le deuxime paramtre ne sert pas, de toute faon */
				       nv_expression->type = EXP_VAR_CTE;
				       nv_expression->code = quelle_fonction(yystack.l_mark[-3].nom_fonction);
				       free(yystack.l_mark[-3].nom_fonction); /* Car cre avec strdup */
				       nv_expression->arg_1.variable = yystack.l_mark[-1].variable;
				       nv_expression->arg_2.valeur = 0.0;
				       yyval.expression = nv_expression;
	                         }
break;
case 53:
#line 616 "formules.y"
	{  Expression *nv_expression;
	                               nv_expression = (Expression *) malloc(sizeof(Expression));
				       if (nv_expression == NULL) {
					 yyerror("Mmoire insuffisante\n");
				       }
				       /* Le deuxime paramtre ne sert pas, de toute faon */
				       nv_expression->type = EXP_ARG_CTE;
				       nv_expression->code = quelle_fonction(yystack.l_mark[-3].nom_fonction);
				       free(yystack.l_mark[-3].nom_fonction); /* Car cre avec strdup */
				       nv_expression->arg_1.expression = yystack.l_mark[-1].expression;
				       nv_expression->arg_2.valeur = 0.0;
				       yyval.expression = nv_expression;
	                         }
break;
case 54:
#line 629 "formules.y"
	{ yyval.expression = yystack.l_mark[0].expression; }
break;
case 55:
#line 630 "formules.y"
	{ yyval.expression = yystack.l_mark[0].expression; }
break;
case 56:
#line 631 "formules.y"
	{ yyval.expression = yystack.l_mark[0].expression; }
break;
case 57:
#line 632 "formules.y"
	{ yyval.expression = yystack.l_mark[0].expression; }
break;
case 58:
#line 633 "formules.y"
	{ yyval.expression = yystack.l_mark[0].expression; }
break;
case 59:
#line 635 "formules.y"
	{ Expression *nv_expression;
	                  nv_expression = (Expression *) malloc(sizeof(Expression));
			  if (nv_expression == NULL) {
			    yyerror("Mmoire insuffisante\n");
			  }
			  nv_expression->type = EXP_CTE_CTE;
			  nv_expression->code = EXP_NOMBRE_ISOLE;
			  nv_expression->arg_1.valeur = yystack.l_mark[0].nombre;
			  yyval.expression = nv_expression;
	                }
break;
case 60:
#line 646 "formules.y"
	{ Expression *nv_expression;
	                            nv_expression = (Expression *) malloc(sizeof(Expression));
				    if (nv_expression == NULL) {
				      yyerror("Mmoire insuffisante\n");
				    }
				    nv_expression->type = EXP_CTE_ARG;
				    nv_expression->code = EXP_PRODUIT;
				    nv_expression->arg_1.valeur = -1.0;
				    nv_expression->arg_2.expression = yystack.l_mark[0].expression;
				    yyval.expression = nv_expression;
                                  }
break;
case 61:
#line 658 "formules.y"
	{ Expression *nv_expression;
	                 nv_expression = (Expression *) malloc(sizeof(Expression));
			 if (nv_expression == NULL) {
			   yyerror("Mmoire insuffisante\n");
			 }
			 nv_expression->type = EXP_VAR_CTE;
			 nv_expression->code = EXP_NOMBRE_ISOLE;
			 nv_expression->arg_1.variable = yystack.l_mark[0].variable;
			 nv_expression->arg_2.variable = NULL;
			 yyval.expression = nv_expression;
                       }
break;
case 62:
#line 671 "formules.y"
	{ switch (yystack.l_mark[0].code_variable)
                         {
			 case 'x': case 'X': yyval.variable = &Var_X; break;
			 case 'y': case 'Y': yyval.variable = &Var_Y; break;
			 case 'z': case 'Z': yyval.variable = &Var_Z; break;
			 case 'i': case 'I': yyval.variable = &Var_I; break;
			 case 't': case 'T': yyval.variable = &Var_T; break;
			 case 'r': case 'R': yyval.variable = &Var_R; break;
			 case 's': yyval.variable = &Var_sX; break;
			 case 'S': yyval.variable = &Var_sY; break;
			 default:
			   {
			     Variable *variable;
			     char nom_variable[ 2 ] = { yystack.l_mark[0].code_variable, 0 };

			     /* On cherche donc dans la table des paramtres */
			     variable = CF_TrouverParametre( nom_variable, nombre_parametres, table_parametres );
			     if ( NULL == variable ) {
			       (void) fprintf(stderr, "%s, %s l.%u : Variable inconnue : %c\n",
					      __FILE__, __FUNCTION__, __LINE__, yystack.l_mark[0].code_variable );
			     }

			     yyval.variable = variable;
			   }
			 }
                       }
break;
case 63:
#line 697 "formules.y"
	{
                         Variable *variable;

			 /* On cherche donc dans la table des paramtres */
			 variable = CF_TrouverParametre( yystack.l_mark[0].nom_fonction, nombre_parametres, table_parametres );
			 if ( NULL == variable ) {
			   (void) fprintf(stderr, "%s, %s l.%u : Variable inconnue : %s\n",
					  __FILE__, __FUNCTION__, __LINE__, yystack.l_mark[0].nom_fonction );
			 }

			 yyval.variable = variable;
	               }
break;
#line 1707 "y.tab.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                yys = yyname[YYTRANSLATE(yychar)];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
