/* LASE - Logiciel d'Analyse des Spectres Exprimentaux
   (C) Emmanuel Curis - 1996  2005

   Fichier  inclure : informations pour gnrer un graphe  partir d'une formule p. ex.
 */

#ifndef INCLURE_GENERER_GRAPHE_H_
# define INCLURE_GENERER_GRAPHE_H_ /* Protection contre l'inclusion multiple */

struct graphe;			/* Dans graphes.h */
struct parametre;		/* Dans modeles.h */
struct serie;			/* Dans serie.h */

/* Dfinition d'une variable au sens utilisateur */

/* Faon de faire varier la variable */
#define VARIABLE_INUTILISEE     0 /* La variable n'a pas  intervenir ! */
#define VARIABLE_MIN_MAX_PAS    1 /* Diverses variantes de gnration automatique */
#define VARIABLE_MIN_PAS_NOMBRE 2
#define VARIABLE_MAX_PAS_NOMBRE 3
#define VARIABLE_MIN_MAX_NOMBRE 4
#define VARIABLE_X_GRAPHE       5 /* Lues dans le X d'un autre graphe */
#define VARIABLE_Y_GRAPHE       6 /* Lues dans le Y d'un autre graphe */
#define VARIABLE_VALEURS        7 /* Srie de valeurs indiques (spares par ;) */
#define VARIABLE_FORMULE        8 /* Calcule  partir des autres variables et de la formule */

#define NOMBRE_METHODES_UTILISABLES 9

struct info_variable {
  char *nom;			/* Nom de la variable [pour affichage seulement !] */
  int type;			/* Faon de connatre les valeurs */
  int grandeur;			/* Type de grandeur physique */
  char *unite;			/* Unit associe */
  double min, max, pas;
  unsigned long nombre;
  char *valeurs;		/* Ou formule ! */
  struct graphe *graphe;	/* dont on prend les X, Y */
};

/* -------- Fonctions pour crer en fonction du genre de donnes */

struct graphe *GRF_GenererFonctionReelle(const char *nom, int type, struct info_variable *X, struct info_variable *Y, struct info_variable *I,
					 unsigned long nbr_parametres, struct parametre *parametres,
					 struct graphe *avant, struct serie *serie);

struct graphe *GRF_GenererSerieValeurs(const char *nom, int type, struct info_variable *Y, struct info_variable *I,
				       unsigned long nbr_parametres, struct parametre *parametres,
				       struct graphe *avant, struct serie *serie);

#endif /* INCLURE_GENERER_GRAPHE_H_ */
