/* LASE - Logiciel d'Analyse des Spectres Expérimentaux
   (c) Emmanuel CURIS 1998 - 2006
   Création : 2 juillet 2006
   
   Toutes les fonctions de calcul probabiliste
   FICHIER À INCLURE
*/

#ifndef LASE_PROBA_H_
# define LASE_PROBA_H_		/* Protection contre l'inclusion multiple */

/* ~-~-~-~-~-~-~-~-~ Calcul des densités de probabilité ~-~-~-~-~-~-~-~-~ */

/* ~-~-~-~-~-~-~-~-~ Calcul des fonctions de répartition ~-~-~-~-~-~-~-~-~
   Toutes ces fonctions calculent p( X <= x ) pour la loi indiquée
 */

/* -------- Variables aléatoires réelles [1 dimension] -------- */

double PROBA_FdR_Gauss         (double x);
double PROBA_FdR_FisherSnedecor( double x, double ddl_numerateur, double ddl_denominateur );
double PROBA_FdR_Student       ( double x, double ddl );

/* -------- Vecteurs aléatoires réels à n dimensions --------
     Dans ce cas, X = (X1, X2, ..., Xn) et on calcule p( ( X1 < x1 ) inter ( X2 < x2 ) inter ... ( Xn < xn ) ) = F(x)
 */

double PROBA_FdR_MultiNormale_Multiplicatif(unsigned int dimension, double *x, double *facteurs );
double PROBA_FdR_MultiNormale_Quelconque   (unsigned int dimension, double *x, double *mat_covariance );

double PROBA_FdR_MultiStudent_Multiplicatif(unsigned int dimension, double *x, double *facteurs, unsigned long ddl);

/* ~-~-~-~-~-~-~-~-~ Calcul des fractiles ~-~-~-~-~-~-~-~-~
   Toutes ces fonctions calculent x tel p( X <= x ) = proba pour la loi indiquée
 */

double PROBA_Fractile_Student(double probabilite, double ddl);
double PROBA_Fractile_Gauss  (double probabilite);

/* ~-~-~-~-~-~-~-~-~ Calcul d'inégalités probabilistes ~-~-~-~-~-~-~-~-~ */

double PROBA_INEG_Bonferroni(double p_global, unsigned long n_evenements);
double PROBA_INEG_Sidak     (double p_global, unsigned long n_evenements);

#endif	/* LASE_PROBA_H_ */
