/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (C) 1998-2006, Emmanuel CURIS
   Cration : mars 2006

   Interface graphique avec l'utilisateur

   Intgration (graphe : rel, complexe)
*/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "systeme.h"
#include "exafs.h"

#include "serie.h"
#include "interface.h"
#include "operations.h"

/* -------- Variables locales -------- */


/* -------- Fonctions locales -------- */

static void HIST_Primitive(Graphe *graphe, Graphe *primitive, union valeur constante, double erreur, int methode);

/* ~-~-~-~-~-~-~-~-~ Intgration d'un graphe [valeurs relles ou complexes] ~-~-~-~-~-~-~-~-~ */

Graphe *I_GRF_Primitive(Graphe *graphe)
{
  Graphe *primitive = NULL; /* Graphe somme */
  int methode = INTG_TRAPEZE;
/*   int reponse; */
  union valeur constante;
/*   struct infos_demande nv_valeur = { 0, NULL, ANGSTROM, NULL, */
/* 				     0.0, 0.0, 0.0, 0.0, 0.0, 0.0 }; */

  /* Contrles prliminaires */
  if (graphe == NULL) return NULL;

  /* Suivant le genre des donnes, quelle routine appelle-t-on ? */
  switch ( graphe->genre_donnees )
  {
  case GRF_FCT_REELLE:
  case GRF_SERIE:
    constante.reel = 0.0;
    /* On demande la constante d'intgration */
/*     nv_valeur.proprietes = 0; */
/*     nv_valeur.texte = "Cte ="; */
/*     nv_valeur.v_initiale = 0.0; */

    OPTION_A_FAIRE( "Demander la mthode d'intgration !" );

/*     reponse = BI_DemandeValeur( NULL, &Q_ConstanteIntegration, &nv_valeur ); */
/*     if ( Q_ConstanteIntegration.bouton_annuler == (unsigned int) reponse ) return NULL; / * On annule * / */

/*     constante = nv_valeur.valeur; */
/*     HIST_Texte(3, 0, "Constante d'int"e_AIGU"gration : %.10g\n", constante ); */

    break;

  case GRF_FCT_COMPLEXE:
    (void) fprintf(stderr, "%s,%s l.%u :  FAIRE --- Primitive d'un graphe complexe\n",
		   __FILE__, __FUNCTION__, __LINE__);
    break;

    if ( NULL == graphe->x ) {
    } else {
    }
    break;
  }

  /* On ralise l'intgration */
  primitive = GRF_Primitive( graphe, methode, constante, 0.0 );

  if ( NULL == primitive ) {
    (void) fprintf(stderr, "%s,%s l.%u : ERREUR survenue...\n",
		   __FILE__, __FUNCTION__, __LINE__);
    return NULL;
  }

  /* Information dans l'historique */
  HIST_Primitive( graphe, primitive, constante, 0.0, methode );

  /* Termin : on renvoie la primitive ainsi obtenue */
  return primitive;
}

/* -------- Sauvegarde dans l'historique -------- */

static void HIST_Primitive(Graphe *graphe, Graphe *primitive, union valeur constante __attribute__((__unused__)), double erreur __attribute__((__unused__)), int methode __attribute__((__unused__)))
{
  /* Log dans l'historique : prliminaire */
  HIST_Titre( 1, "Estimation d'une primitive", "Maths" );
  HIST_Texte( 1, 0, "Graphe int"e_AIGU"gr"e_AIGU" : %s\n", graphe->nom );
  HIST_Texte( 1, 0, "Graphe de la primitive : %s\n", primitive->nom );
}
