/* LASE - Logiciel d'Analyse des Spectres Exprimentaux
   (C) 1996-2002, Emmanuel Curis

   Interface utilisateur : routines gnrales indpendantes du systme

   Fonctions avances pour l'historique des oprations
*/

#include <stdlib.h>
#include <stdio.h>

#include "systeme.h"
#include "graphes.h"

#include "interface.h"

#include "pointeur.txt"

/* ~~~~~~~~ Variables locales ~~~~~~~~ */

/* ~~~~~~~~ Fonctions locales ~~~~~~~~ */

/* ~~~~~~~~ Ralisation pratique ~~~~~ */

/* --------------- Trac d'un pointeur (vertical) dans une fentre ----------------------------\
 |    Renvoie VRAI si tout s'est pass comme il faut (vnement trait)                        |
 |    Suppose que fenetre->pointeur contienne l'adresse du graphe en cours dans la fentre     |
 |                                                                                             |
 | fenetre : structure associe  la fentre dans laquelle on travaille                        |
 | x_souris, y_souris : coordonnes de la souris                                               |
 \-------------------------------------------------------------------------------------------- */

void RCT_pointeur(Fenetre *fenetre, int x, int y, int vx_x, int vx_y)
{
  Graphe  *graphe;
  double echelle_X, x_reel;
  char *texte;

  graphe = (Graphe *) FEN_LireComplement( fenetre, FEN_INFOS_GRAPHE );
  if (graphe == NULL) return;

  if ( graphe->x_min == graphe->x_max ) return; /* Pas de pointeur si bornes identiques... */

  TRC_Mode( BI_MODE_INVERSE );
  TRC_Couleur( NOIR );
  TRC_Style( BI_CONTINU );

  /* On efface l'ancien pointeur */
  if ( ( vx_x >= 0 ) && ( vx_x < (int) fenetre->w_larg ) &&
       ( vx_y >= 0 ) && ( vx_y < (int) fenetre->w_haut ) ) { /* Il tait bien sur la fentre */
    TRC_LigneV( fenetre, vx_x, 0, fenetre->w_haut );
  }

  if ( ( y < 0 ) || ( y >= (int) fenetre->w_haut ) ||  /* Souris hors de la partie intressante */
       ( x < 0 ) || ( x >= (int) fenetre->w_larg ) ) {
    return;
  }

  /* On trace la ligne  */
  TRC_LigneV( fenetre, x, 0, fenetre->w_haut );

  /* chelle horizontale, en vrai / pixels par compatibilit avec le reste */
  echelle_X = (graphe->x_max - graphe->x_min) / ( (double) fenetre->w_larg );
  x_reel = TRC_ConvertitX_EvP( x, graphe->x_min, 0, echelle_X );

  /* Recherche des units */
  texte = TXT_genere_chaine( texte_valeur_x, x_reel, GRF_QuelleUnite( graphe, AXE_X ) );
  FEN_infos( fenetre, texte );
  free( texte ); texte = NULL;
}
