/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (C) 1996-2002, Emmanuel CURIS
   Cration de ce fichier : 6 septembre 2002

   Routines gnriques pour les ajustements

   Ajustement proprement dit d'un modle quelconque
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "systeme.h"

#include "couches.h"
#include "modeles.h"

/* ~~~~~~~~ Variables locales ~~~~~~~~ */

/* ~~~~~~~~ Fonctions locales ~~~~~~~~ */

/* ~~~~~~~~ Ralisation pratique ~~~~~ */

int MODELE_CalculerModele(ModeleAjustement *modele)
{
  int retour = 0;
  unsigned int i;

  if (NULL == modele) return -1;

  switch (modele->type)
  {
  case MODELE_MULTI_MODELES:
    for (i = 0 ; i <  modele->infos_modele.modeles->nbr_modeles ; i++) {
      retour |= MODELE_CalculerModele( modele->infos_modele.modeles->modeles[i] );
    }
    break;

  case MODELE_CL_MODELES:
    OPTION_A_FAIRE( "calcul des CL de modles");
    break;

  case MODELE_EXAFS_CHEMINS:
    retour = NC_CalculeEXAFS(modele);
    break;

  case MODELE_EXAFS_GNXAS:
  case MODELE_SEUIL_BASIQUE:
  case MODELE_FLUOX:
  case MODELE_DECOMPOSITION:
    (void) fprintf(stderr, "MODELE_CalculerModele : type de modle pas encore support [%d]\n", modele->type);
    break;

  case MODELE_GENERIQUE:
    retour = MODELE_Generique_CalculerModele( modele );
    break;

  default:
    AVERTISSEMENT( "Type de modle inconnu [%d]", modele->type );
    retour = -2;
  }

  /* Tout s'est bien pass */
  return retour;
}
